Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -5107,94 +5022,196 @@
 
                 k_ppp = k + 3 * ibit8
-                k_pp  = k + 2 * ( 1 - ibit6  )
+                k_pp  = k + 2 * ( 1 - ibit6 )
                 k_mm  = k - 2 * ibit8
 
-                w_comp = w(k,j,i) + w(k,j,i-1)
-                flux_t = w_comp * rho_air_zw(k) * (                            &
-                          ( 37.0_wp * ibit8 * adv_mom_5                        &
-                       +     7.0_wp * ibit7 * adv_mom_3                        &
-                       +              ibit6 * adv_mom_1                        &
-                          ) *                                                  &
-                             ( u(k+1,j,i)  + u(k,j,i)     )                    &
-                   -      (  8.0_wp * ibit8 * adv_mom_5                        &
-                       +              ibit7 * adv_mom_3                        &
-                          ) *                                                  &
-                             ( u(k_pp,j,i) + u(k-1,j,i)   )                    &
-                   +      (           ibit8 * adv_mom_5                        &
-                          ) *                                                  &
-                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                    &
-                                      )
-
-                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                   &
-                          ( 10.0_wp * ibit8 * adv_mom_5                        &
-                       +     3.0_wp * ibit7 * adv_mom_3                        &
-                       +              ibit6 * adv_mom_1                        &
-                          ) *                                                  &
-                             ( u(k+1,j,i)   - u(k,j,i)    )                    &
-                   -      (  5.0_wp * ibit8 * adv_mom_5                        &
-                       +              ibit7 * adv_mom_3                        &
-                          ) *                                                  &
-                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                    &
-                   +      (           ibit8 * adv_mom_5                        &
-                           ) *                                                 &
-                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                    &
-                                              )
+                w_comp(k) = w(k,j,i) + w(k,j,i-1)
+                flux_t(k) = w_comp(k) * rho_air_zw(k) * (                      &
+                           ( 37.0_wp * ibit8 * adv_mom_5                       &
+                        +     7.0_wp * ibit7 * adv_mom_3                       &
+                        +              ibit6 * adv_mom_1                       &
+                           ) *                                                 &
+                                      ( u(k+1,j,i)   + u(k,j,i)    )           &
+                    -      (  8.0_wp * ibit8 * adv_mom_5                       &
+                        +              ibit7 * adv_mom_3                       &
+                           ) *                                                 &
+                                      ( u(k_pp,j,i)  + u(k-1,j,i)  )           &
+                    +      (           ibit8 * adv_mom_5                       &
+                           ) *                                                 &
+                                      ( u(k_ppp,j,i) + u(k_mm,j,i) )           &
+                                                        )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (             &
+                           ( 10.0_wp * ibit8 * adv_mom_5                       &
+                        +     3.0_wp * ibit7 * adv_mom_3                       &
+                        +              ibit6 * adv_mom_1                       &
+                           ) *                                                 &
+                                      ( u(k+1,j,i)   - u(k,j,i)    )           &
+                    -      (  5.0_wp * ibit8 * adv_mom_5                       &
+                        +              ibit7 * adv_mom_3                       &
+                           ) *                                                 &
+                                      ( u(k_pp,j,i)  - u(k-1,j,i)  )           &
+                    +      (           ibit8 * adv_mom_5                       &
+                           ) *                                                 &
+                                      ( u(k_ppp,j,i) - u(k_mm,j,i) )           &
+                                                                 )
+             ENDDO
+!
+!--          Set resolved/turbulent flux at model top to zero (w-level). In case that
+!--          a symmetric behavior between bottom and top shall be guaranteed (closed
+!--          channel flow), the flux at nzt is also set to zero.
+             IF ( symmetry_flag == 1 ) THEN
+                flux_t(nzt) = 0.0_wp
+                diss_t(nzt) = 0.0_wp
+                w_comp(nzt) = 0.0_wp
+             ENDIF
+             flux_t(nzt+1) = 0.0_wp
+             diss_t(nzt+1) = 0.0_wp
+             w_comp(nzt+1) = 0.0_wp
+
+             DO  k = nzb+1, nzb_max_l
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+
+                ibit2 = REAL( IBITS(advc_flags_m(k,j,i),2,1), KIND = wp )
+                ibit1 = REAL( IBITS(advc_flags_m(k,j,i),1,1), KIND = wp )
+                ibit0 = REAL( IBITS(advc_flags_m(k,j,i),0,1), KIND = wp )
+
+                ibit5 = REAL( IBITS(advc_flags_m(k,j,i),5,1), KIND = wp )
+                ibit4 = REAL( IBITS(advc_flags_m(k,j,i),4,1), KIND = wp )
+                ibit3 = REAL( IBITS(advc_flags_m(k,j,i),3,1), KIND = wp )
+
+                ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
 !
 !--             Calculate the divergence of the velocity field. A respective
-!--             correction is needed to overcome numerical instabilities caused
+!--             correction is needed to overcome numerical instabilities introduced
 !--             by a not sufficient reduction of divergences near topography.
-                div = ( ( u_comp      - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx  &
-                     +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy  &
-                     +  (   w_comp                      * rho_air_zw(k) -      &
-                          ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)      &
-                        ) * drho_air(k) * ddzw(k)                              &
+                div = ( ( u_comp(k)       * ( ibit0 + ibit1 + ibit2 )            &
+                      - ( u(k,j,i)   + u(k,j,i-1)   )                            &
+                                          * (                                    &
+                           REAL( IBITS(advc_flags_m(k,j,i-1),0,1),  KIND = wp )  &
+                         + REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )   &
+                         + REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )   &
+                                            )                                    &
+                        ) * ddx                                                  &
+                     +  ( ( v_comp(k) + gv ) * ( ibit3 + ibit4 + ibit5 )         &
+                        - ( v(k,j,i)   + v(k,j,i-1 )  )                          &
+                                          * (                                    &
+                           REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )   &
+                         + REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )   &
+                         + REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )   &
+                                            )                                    &
+                        ) * ddy                                                  &
+                     +  ( w_comp(k)   * rho_air_zw(k) * ( ibit6 + ibit7 + ibit8 )&
+                      -   w_comp(k-1) * rho_air_zw(k-1)                          &
+                                          * (                                    &
+                           REAL( IBITS(advc_flags_m(k-1,j,i),6,1), KIND = wp )   &
+                         + REAL( IBITS(advc_flags_m(k-1,j,i),7,1), KIND = wp )   &
+                         + REAL( IBITS(advc_flags_m(k-1,j,i),8,1), KIND = wp )   &
+                                            )                                    &
+                        ) * drho_air(k) * ddzw(k)                                &
                       ) * 0.5_wp
 
-                tend(k,j,i) = tend(k,j,i) - (                                  &
-                 ( ( flux_r + diss_r )                                         &
-               -   ( flux_l + diss_l ) ) * ddx                                 &
-               + ( ( flux_n + diss_n )                                         &
-               -   ( flux_s + diss_s ) ) * ddy                                 &
-               + ( ( flux_t + diss_t )                                         &
-               -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)               &
-                                           ) + div * u(k,j,i)
-
+                tend(k,j,i) = tend(k,j,i) - (                                    &
+                                  ( flux_r(k) + diss_r(k)                        &
+                                -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx  &
+                                + ( flux_n(k) + diss_n(k)                        &
+                                -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy  &
+                                + ( ( flux_t(k) + diss_t(k) )                    &
+                                -   ( flux_d    + diss_d    )                    &
+                                                       ) * drho_air(k) * ddzw(k) &
+                                             ) + div * u(k,j,i)
 #ifndef _OPENACC
-                swap_flux_x_local_u(k,j) = flux_r
-                swap_diss_x_local_u(k,j) = diss_r
-                swap_flux_y_local_u(k)   = flux_n
-                swap_diss_y_local_u(k)   = diss_n
+!
+!--             Swap fluxes. Note, in the OPENACC case these are computed again.
+                flux_l_u(k,j,tn) = flux_r(k)
+                diss_l_u(k,j,tn) = diss_r(k)
+                flux_s_u(k,tn)   = flux_n(k)
+                diss_s_u(k,tn)   = diss_n(k)
 #endif
-                flux_d                   = flux_t
-                diss_d                   = diss_t
-!
-!--             Statistical Evaluation of u'u'. The factor has to be applied
-!--             for right evaluation when gallilei_trans = .T. .
-                !$ACC ATOMIC
-                sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                      &
-                + ( flux_r                                                     &
-                    * ( u_comp - 2.0_wp * hom(k,1,1,0)                   )     &
-                    / ( u_comp - gu + SIGN( 1.0E-20_wp, u_comp - gu )    )     &
-                  + diss_r                                                     &
-                    *   ABS( u_comp - 2.0_wp * hom(k,1,1,0)              )     &
-                    / ( ABS( u_comp - gu ) + 1.0E-20_wp                  )     &
-                  ) *   weight_substep(intermediate_timestep_count)
+!
+!--             Statistical Evaluation of u'u'. The factor has to be applied for
+!--             right evaluation when gallilei_trans = .T. .
+                sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                           &
+                      + ( flux_r(k)                                                 &
+                          * ( u_comp(k) - 2.0_wp * hom(k,1,1,0)                   ) &
+                          / ( u_comp(k) - gu + SIGN( 1.0E-20_wp, u_comp(k) - gu ) ) &
+                        + diss_r(k)                                                 &
+                          *   ABS( u_comp(k) - 2.0_wp * hom(k,1,1,0)              ) &
+                          / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp                  ) &
+                        ) *   weight_substep(intermediate_timestep_count)
 !
 !--             Statistical Evaluation of w'u'.
-                !$ACC ATOMIC
-                sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                    &
-                + ( flux_t                                                     &
-                    * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
-                    / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-                  + diss_t                                                     &
-                    *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
-                    / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
-                  ) *   weight_substep(intermediate_timestep_count)
+                sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                         &
+                      + ( flux_t(k)                                                 &
+                          * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                   ) &
+                          / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )           ) &
+                        + diss_t(k)                                                 &
+                          *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)              ) &
+                          / ( ABS( w_comp(k) ) + 1.0E-20_wp                       ) &
+                        ) *   weight_substep(intermediate_timestep_count)
+             ENDDO
+
+             DO  k = nzb_max_l+1, nzt
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities introduced
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp(k)       - ( u(k,j,i)   + u(k,j,i-1) ) ) * ddx      &
+                     +  ( v_comp(k) + gv  - ( v(k,j,i)   + v(k,j,i-1) ) ) * ddy      &
+                     +  ( w_comp(k)   * rho_air_zw(k)                                &
+                       -  w_comp(k-1) * rho_air_zw(k-1)                              &
+                        ) * drho_air(k) * ddzw(k)                                    &
+                      ) * 0.5_wp
+
+                tend(k,j,i) = tend(k,j,i) - (                                        &
+                                  ( flux_r(k) + diss_r(k)                            &
+                                -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx      &
+                                + ( flux_n(k) + diss_n(k)                            &
+                                -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy      &
+                                + ( ( flux_t(k) + diss_t(k) )                        &
+                                -   ( flux_d    + diss_d    )                        &
+                                                          ) * drho_air(k) * ddzw(k)  &
+                                             ) + div * u(k,j,i)
+#ifndef _OPENACC
+                flux_l_u(k,j,tn) = flux_r(k)
+                diss_l_u(k,j,tn) = diss_r(k)
+                flux_s_u(k,tn)   = flux_n(k)
+                diss_s_u(k,tn)   = diss_n(k)
+#endif
+!
+!--             Statistical Evaluation of u'u'. The factor has to be applied for
+!--             right evaluation when gallilei_trans = .T. .
+                sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                            &
+                      + ( flux_r(k)                                                  &
+                          * ( u_comp(k) - 2.0_wp * hom(k,1,1,0)                   )  &
+                          / ( u_comp(k) - gu + SIGN( 1.0E-20_wp, u_comp(k) - gu ) )  &
+                        + diss_r(k)                                                  &
+                          *   ABS( u_comp(k) - 2.0_wp * hom(k,1,1,0)              )  &
+                          / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp                  )  &
+                        ) *   weight_substep(intermediate_timestep_count)
+!
+!--             Statistical Evaluation of w'u'.
+                sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                          &
+                      + ( flux_t(k)                                                  &
+                          * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                   )  &
+                          / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )           )  &
+                        + diss_t(k)                                                  &
+                          *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)              )  &
+                          / ( ABS( w_comp(k) ) + 1.0E-20_wp                       )  &
+                        ) *   weight_substep(intermediate_timestep_count)
              ENDDO
           ENDDO
        ENDDO
 
+       CALL cpu_log( log_point_s(68), 'advec_u_ws', 'stop' )
+
     END SUBROUTINE advec_u_ws
-    
+
 
 !------------------------------------------------------------------------------!
@@ -5212,7 +5229,7 @@
        INTEGER(iwp) ::  k_pp      !< k+2 index in disretization, can be modified to avoid segmentation faults
        INTEGER(iwp) ::  k_ppp     !< k+3 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms 
+       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms
        INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
-       
+
        REAL(wp)    ::  ibit9 !< flag indicating 1st-order scheme along x-direction
        REAL(wp)    ::  ibit10 !< flag indicating 3rd-order scheme along x-direction
@@ -5231,73 +5248,76 @@
        REAL(wp)    ::  ibit14_s !< flag indicating 5th-order scheme along y-direction
 #endif
-       REAL(wp)    ::  ibit15 !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)    ::  ibit16 !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)    ::  ibit17 !< flag indicating 5th-order scheme along z-direction
-       REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
-       REAL(wp)    ::  div    !< diverence on v-grid
-       REAL(wp)    ::  flux_d !< artificial 6th-order flux at grid box bottom
-       REAL(wp)    ::  gu     !< Galilei-transformation velocity along x
-       REAL(wp)    ::  gv     !< Galilei-transformation velocity along y
-       REAL(wp)    ::  u_comp !< advection velocity along x
+       REAL(wp)    ::  ibit15   !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit16   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit17   !< flag indicating 5th-order scheme along z-direction
+       REAL(wp)    ::  diss_d   !< artificial dissipation term at grid box bottom
+       REAL(wp)    ::  div      !< diverence on v-grid
+       REAL(wp)    ::  flux_d   !< artificial 6th-order flux at grid box bottom
+       REAL(wp)    ::  gu       !< Galilei-transformation velocity along x
+       REAL(wp)    ::  gv       !< Galilei-transformation velocity along y
 #ifdef _OPENACC
-       REAL(wp)    ::  u_comp_l !< advection velocity along x
+       REAL(wp)    ::  u_comp_l !< advection velocity along x at leftward side
+       REAL(wp)    ::  v_comp_s !< advection velocity along y at southward side
 #endif
-       REAL(wp)    ::  w_comp !< advection velocity along z
-       
-       REAL(wp)    ::  diss_s !< discretized artificial dissipation at southward-side of the grid box
-       REAL(wp)    ::  flux_s !< discretized 6th-order flux at southward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local_v !< discretized artificial dissipation at southward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local_v !< discretized 6th-order flux at southward-side of the grid box
-#endif
-       
-       REAL(wp)    ::  diss_l !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp)    ::  flux_l !< discretized 6th-order flux at leftward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_v !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_v !< discretized 6th-order flux at leftward-side of the grid box
-#endif
-       
-       REAL(wp)    ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp)    ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp)    ::  diss_t !< discretized artificial dissipation at top of the grid box
-       REAL(wp)    ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp)    ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
-       REAL(wp)    ::  flux_t !< discretized 6th-order flux at top of the grid box
-       REAL(wp)    ::  v_comp !< advection velocity along y
-#ifdef _OPENACC
-       REAL(wp)    ::  v_comp_s !<
-#endif
-!
-!--    Set local version of nzb_max. At non-cyclic boundaries the order of the 
-!--    advection need to be degraded near the boundary. Please note, in contrast
-!--    to the cache-optimized routines, nzb_max_l is set constantly for the 
-!--    entire subdomain, in order to avoid unsymmetric loops which might be 
-!--    an issue for GPUs.
-       IF( bc_dirichlet_l  .OR.  bc_radiation_l  .OR.                          &
-           bc_dirichlet_r  .OR.  bc_radiation_r  .OR.                          &
-           bc_dirichlet_s  .OR.  bc_radiation_s  .OR.                          &
-           bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
-          nzb_max_l = nzt
-       ELSE
-          nzb_max_l = nzb_max
-       END IF
-       
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_t !< discretized artificial dissipation at top of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_t !< discretized 6th-order flux at top of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  u_comp !< advection velocity along x
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  v_comp !< advection velocity along y
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  w_comp !< advection velocity along z
+
+       CALL cpu_log( log_point_s(69), 'advec_v_ws', 'start' )
+
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
 
+       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
+       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
+       !$ACC PRIVATE(ibit9, ibit10, ibit11, ibit12, ibit13, ibit14) &
+       !$ACC PRIVATE(ibit15, ibit16, ibit17) &
+       !$ACC PRIVATE(ibit9_l, ibit10_l, ibit11_l) &
+       !$ACC PRIVATE(ibit12_s, ibit13_s, ibit14_s) &
+       !$ACC PRIVATE(flux_r, diss_r) &
+       !$ACC PRIVATE(flux_n, diss_n) &
+       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
+       !$ACC PRIVATE(flux_l_v, diss_l_v, flux_s_v, diss_s_v) &
+       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
+       !$ACC PRESENT(advc_flags_m) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
+       !$ACC PRESENT(tend) &
+       !$ACC PRESENT(hom(:,1,1:3,0)) &
+       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
+       !$ACC PRESENT(sums_vs2_ws_l, sums_wsvs_ws_l)
+       DO  i = nxl, nxr
+          DO  j = nysv, nyn
+!
+!--          Used local modified copy of nzb_max (used to degrade order of
+!--          discretization) at non-cyclic boundaries. Modify only at relevant points
+!--          instead of the entire subdomain. This should lead to better
+!--          load balance between boundary and non-boundary PEs.
+             IF( ( bc_dirichlet_l  .OR.  bc_radiation_l )  .AND.  i <= nxl + 2  .OR. &
+                 ( bc_dirichlet_r  .OR.  bc_radiation_r )  .AND.  i >= nxr - 2  .OR. &
+                 ( bc_dirichlet_s  .OR.  bc_radiation_s )  .AND.  j <= nys + 2  .OR. &
+                 ( bc_dirichlet_n  .OR.  bc_radiation_n )  .AND.  j >= nyn - 2 )  THEN
+                nzb_max_l = nzt
+             ELSE
+                nzb_max_l = nzb_max
+             END IF
+
 #ifndef _OPENACC
-!
-!--    First compute the whole left boundary of the processor domain
-       i = nxl
-       DO  j = nysv, nyn
-          DO  k = nzb+1, nzb_max_l
-
-             ibit11 = REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )
-             ibit10 = REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )
-             ibit9  = REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )
-
-             u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
-             swap_flux_x_local_v(k,j) = u_comp * (                             &
+             IF ( i == nxl )  THEN
+                DO  k = nzb+1, nzb_max_l
+
+                   ibit11 = REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )
+                   ibit10 = REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )
+                   ibit9  = REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )
+
+                   u_comp(k)        = u(k,j-1,i) + u(k,j,i) - gu
+                   flux_l_v(k,j,tn) = u_comp(k) * (                            &
                                       ( 37.0_wp * ibit11 * adv_mom_5           &
                                    +     7.0_wp * ibit10 * adv_mom_3           &
@@ -5314,5 +5334,5 @@
                                                  )
 
-              swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                   &
+                   diss_l_v(k,j,tn) = - ABS( u_comp(k) ) * (                   &
                                       ( 10.0_wp * ibit11 * adv_mom_5           &
                                    +     3.0_wp * ibit10 * adv_mom_3           &
